<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<itemFormativoEsercizio nomeDescrittivo="Suoneria a basso consumo per avviso apertura porta" identificatoreArgomento="esercizio37" prerequisiti="digitalInput,digitalOutput,debouncing,swpowersave" tags="Avanzato,DigitalInput,DigitalOutput,Software,Rimbalzi,Risparmio energetico,PBL" fondamentale="false" mdPblproblem="true" mdPblnewlearninggoal="true" tempoRichiesto="0" tipoTempo="Ore" versione="1">
    <mdprerequisitelist>Modalità di risparmio energetico</mdprerequisitelist>
    <mdprerequisitelist>Interrupt</mdprerequisitelist>
    <mdprerequisitelist>Problema dei rimbalzi</mdprerequisitelist>
    <mdcomponentlist>Relè reed (Es. KY-019)</mdcomponentlist>
    <mdcomponentlist>Buzzer attivo (Es. KY-012)</mdcomponentlist>
    <mdwhy>Quando si utilizzano le modalità a basso consumo con eventi generati da interruttori meccanici di qualche tipo, i rimbalzi possono causare comportamenti anomali.&#13;
L'esercizio, principalmente legato allo sviluppo software, mette in evidenza l'interazione tra uso delle varie modalità a basso consumo e problema dei rimbalzi.</mdwhy>
    <mdexpectedresult>Costruire un oggetto che rileva l'apertura di un contatto e, al verificarsi dell'evento, fa suonare un buzzer per generare un breve suono.&#13;
&#13;
Progettare il software affinché sia possibile alimentare l'oggetto anche a batteria, il microcontrollore quindi deve rimanere in modalità a basso consumo e riattivarsi solo all'apertura del contatto e limitatamente al tempo in cui deve suonare il buzzer.&#13;
&#13;
Partire dal presupposto che l'utente deve anche poter decidere di lasciare la porta aperta, tale azione dovrà rendere inattivo l'oggetto senza costringere l'utente a spegnerlo per impedire che si scarichi la batteria.</mdexpectedresult>
    <mdextras>Per ESP8266, utilizzare una soluzione per gestire la modalità deep sleep aggiungendo un transistor come indicato nel secondo schema.</mdextras>
    <mderraticbehavior>Vedi dettagli PBL</mderraticbehavior>
    <mdcommonerrors></mdcommonerrors>
    <mdlessonlearned>Imparare ad individuare momenti di inattività in cui sfruttare le modalità di risparmio energetico per minimizzare i consumi.</mdlessonlearned>
    <mdsolution>Utilizzare la modalità per il risparmio energetico massimo prevista che consente il risveglio con interrupt sul microcontrollore in uso.&#13;
&#13;
Vedi dettagli PBL</mdsolution>
    <mdpbldetails>La criticità sta nel modo di rilevare l'apertura e la chiusura della porta, qualora l'evento che genera il risveglio del microcontrollore sia l'apertura della porta, si potrebbe tornare alla modalità a basso consumo subito dopo l'emissione del suono tornando in attesa di una nuova apertura, però se si chiudesse la porta sbattendola con forza si potrebbe generare un rimbalzo del relè reed visto come nuova apertura che causerebbe l'emissione di un altro suono che, per requisiti dell'esercizio, non deve esserci.&#13;
&#13;
Il microcontrollore, dovrà tornare sempre alla modalità a basso consumo migliore disponibile in base alla situazione, gestendo anche l'eventuale scelta dell'utente di lasciare la porta aperta per poi chiuderla in seguito e gestendo l'anomalia del rimbalzo in chiusura.&#13;
&#13;
Una tra le possibili opzioni è rilevare l'apertura, emettere il suono, aggiornare una variabile di stato, poi fare un polling dello stato della porta per attendere che si chiuda ma in modalità "basso consumo" cioè sostituendo il classico delay con un breve passaggio a standby, ripetuto fino al rilevamento della chiusura della porta.&#13;
Questo breve standby si ottiene abilitando un apposito watchdog, che consente di far risvegliare dallo standby il microcontrollore dopo un numero di secondi scelto (da 1 a 8).</mdpbldetails>
    <risorseCollegate>
        <datiRisorsaCollegata>
            <nomeFile>campanello_porta.ino</nomeFile>
            <testoDescrittivo></testoDescrittivo>
            <identificativoFile>idCampanelloATMega</identificativoFile>
        </datiRisorsaCollegata>
    </risorseCollegate>
    <risorseCollegate>
        <datiRisorsaCollegata>
            <nomeFile>campanello_porta_esp8266.ino</nomeFile>
            <testoDescrittivo></testoDescrittivo>
            <identificativoFile>idCampanelloESP</identificativoFile>
        </datiRisorsaCollegata>
    </risorseCollegate>
</itemFormativoEsercizio>
